Index: src/Actions/MoleculeAction/SaveTemperatureAction.def
===================================================================
--- src/Actions/MoleculeAction/SaveTemperatureAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/MoleculeAction/SaveTemperatureAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * SaveTemperatureAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+class MoleculeListClass;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (std::string)
+#define paramtokens (MoleculeSaveTemperatureAction::NAME)
+#define paramreferences (temperaturefile)
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Molecule
+#define ACTIONNAME SaveTemperature
+#define TOKEN "save-temperature"
+
Index: src/Actions/MoleculeAction/SaveTemperatureAction.hpp
===================================================================
--- src/Actions/MoleculeAction/SaveTemperatureAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/MoleculeAction/SaveTemperatureAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -10,31 +10,7 @@
 
 #include "Actions/Action.hpp"
-#include "Actions/Process.hpp"
 
-class MoleculeListClass;
-
-void MoleculeSaveTemperature(std::string &temperaturefile);
-
-class MoleculeSaveTemperatureAction : public Action {
-  friend void MoleculeSaveTemperature(std::string &temperaturefile);
-
-public:
-  MoleculeSaveTemperatureAction();
-  virtual ~MoleculeSaveTemperatureAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
-
+#include "SaveTemperatureAction.def"
+#include "Action_impl_header.hpp"
 
 #endif // SAVETEMPERATUREACTION_HPP
Index: src/Actions/MoleculeAction/SuspendInWaterAction.cpp
===================================================================
--- src/Actions/MoleculeAction/SuspendInWaterAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/MoleculeAction/SuspendInWaterAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * SuspendInWaterAction.cpp
@@ -6,12 +13,15 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/MoleculeAction/SuspendInWaterAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "boundary.hpp"
 #include "config.hpp"
-#include "log.hpp"
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
 
@@ -21,58 +31,24 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/MoleculeAction/SuspendInWaterAction.hpp"
 
-/****** MoleculeSuspendInWaterAction *****/
-
-// memento to remember the state when undoing
-
-//class MoleculeSuspendInWaterState : public ActionState {
-//public:
-//  MoleculeSuspendInWaterState(molecule* _mol,std::string _lastName) :
-//    mol(_mol),
-//    lastName(_lastName)
-//  {}
-//  molecule* mol;
-//  std::string lastName;
-//};
-
-const char MoleculeSuspendInWaterAction::NAME[] = "suspend-in-water";
-
-MoleculeSuspendInWaterAction::MoleculeSuspendInWaterAction() :
-  Action(NAME)
-{}
-
-MoleculeSuspendInWaterAction::~MoleculeSuspendInWaterAction()
-{}
-
-void MoleculeSuspendInWater(double density) {
-  ValueStorage::getInstance().setCurrentValue(MoleculeSuspendInWaterAction::NAME, density);
-  ActionRegistry::getInstance().getActionByName(MoleculeSuspendInWaterAction::NAME)->call(Action::NonInteractive);
-};
-
-Dialog* MoleculeSuspendInWaterAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryDouble(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
+// and construct the stuff
+#include "SuspendInWaterAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
 Action::state_ptr MoleculeSuspendInWaterAction::performCall() {
   molecule *mol = NULL;
-  double density;
   double volume = 0.;
 
-  ValueStorage::getInstance().queryCurrentValue(NAME, density);
+  // obtain information
+  getParametersfromValueStorage();
 
   for (World::MoleculeSelectionIterator iter = World::getInstance().beginMoleculeSelection(); iter != World::getInstance().endMoleculeSelection(); ++iter) {
     mol = iter->second;
     DoLog(0) && (Log() << Verbose(0) << "Evaluating necessary cell volume for a cluster suspended in water.");
-    if (density < 1.0) {
+    if (params.density < 1.0) {
       DoeLog(1) && (eLog()<< Verbose(1) << "Density must be greater than 1.0g/cm^3!" << endl);
     } else {
-      PrepareClustersinWater(World::getInstance().getConfig(), mol, volume, density);  // if volume == 0, will calculate from ConvexEnvelope
+      PrepareClustersinWater(World::getInstance().getConfig(), mol, volume, params.density);  // if volume == 0, will calculate from ConvexEnvelope
     }
   }
@@ -105,2 +81,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/MoleculeAction/SuspendInWaterAction.def
===================================================================
--- src/Actions/MoleculeAction/SuspendInWaterAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/MoleculeAction/SuspendInWaterAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * SuspendInWaterAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+class MoleculeListClass;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (double)
+#define paramtokens (MoleculeSuspendInWaterAction::NAME)
+#define paramreferences (density)
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Molecule
+#define ACTIONNAME SuspendInWater
+#define TOKEN "suspend-in-water"
+
Index: src/Actions/MoleculeAction/SuspendInWaterAction.hpp
===================================================================
--- src/Actions/MoleculeAction/SuspendInWaterAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/MoleculeAction/SuspendInWaterAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -10,31 +10,7 @@
 
 #include "Actions/Action.hpp"
-#include "Actions/Process.hpp"
 
-class MoleculeListClass;
-
-void MoleculeSuspendInWater(double density);
-
-class MoleculeSuspendInWaterAction : public Action {
-  friend void MoleculeSuspendInWater(double density);
-
-public:
-  MoleculeSuspendInWaterAction();
-  virtual ~MoleculeSuspendInWaterAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
-
+#include "SuspendInWaterAction.def"
+#include "Action_impl_header.hpp"
 
 #endif // SUSPENDINWATERACTION_HPP
Index: src/Actions/MoleculeAction/VerletIntegrationAction.cpp
===================================================================
--- src/Actions/MoleculeAction/VerletIntegrationAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/MoleculeAction/VerletIntegrationAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * VerletIntegrationAction.cpp
@@ -6,11 +13,14 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/MoleculeAction/VerletIntegrationAction.hpp"
-#include "Actions/ActionRegistry.hpp"
-#include "log.hpp"
+#include "Helpers/Log.hpp"
 #include "molecule.hpp"
-#include "verbose.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
 
@@ -21,49 +31,15 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/MoleculeAction/VerletIntegrationAction.hpp"
 
-/****** MoleculeVerletIntegrationAction *****/
-
-// memento to remember the state when undoing
-
-//class MoleculeVerletIntegrationState : public ActionState {
-//public:
-//  MoleculeVerletIntegrationState(molecule* _mol,std::string _lastName) :
-//    mol(_mol),
-//    lastName(_lastName)
-//  {}
-//  molecule* mol;
-//  std::string lastName;
-//};
-
-const char MoleculeVerletIntegrationAction::NAME[] = "verlet-integrate";
-
-MoleculeVerletIntegrationAction::MoleculeVerletIntegrationAction() :
-  Action(NAME)
-{}
-
-MoleculeVerletIntegrationAction::~MoleculeVerletIntegrationAction()
-{}
-
-void MoleculeVerletIntegration(std::string &forcesfile) {
-  ValueStorage::getInstance().setCurrentValue(MoleculeVerletIntegrationAction::NAME, forcesfile);
-  ActionRegistry::getInstance().getActionByName(MoleculeVerletIntegrationAction::NAME)->call(Action::NonInteractive);
-};
-
-Dialog* MoleculeVerletIntegrationAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryString(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
+// and construct the stuff
+#include "VerletIntegrationAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
 Action::state_ptr MoleculeVerletIntegrationAction::performCall() {
-  string filename;
   molecule *mol = NULL;
 
-  ValueStorage::getInstance().queryCurrentValue(NAME, filename);
+  // obtain information
+  getParametersfromValueStorage();
 
   for (World::MoleculeSelectionIterator iter = World::getInstance().beginMoleculeSelection(); iter != World::getInstance().endMoleculeSelection(); ++iter) {
@@ -72,9 +48,9 @@
     // TODO: sollte besser stream nutzen, nicht filename direkt (es sei denn, ist prefix), besser fuer unit test
     char outputname[MAXSTRINGSIZE];
-    strcpy(outputname, filename.c_str());
+    strcpy(outputname, params.forcesfile.c_str());
     if (!mol->VerletForceIntegration(outputname, *(World::getInstance().getConfig()), 0))
-      DoLog(2) && (Log() << Verbose(2) << "File not found." << endl);
+      DoLog(2) && (Log() << Verbose(2) << "File " << params.forcesfile << " not found." << endl);
     else
-      DoLog(2) && (Log() << Verbose(2) << "File found and parsed." << endl);
+      DoLog(2) && (Log() << Verbose(2) << "File " << params.forcesfile << " found and parsed." << endl);
   }
   return Action::success;
@@ -106,2 +82,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/MoleculeAction/VerletIntegrationAction.def
===================================================================
--- src/Actions/MoleculeAction/VerletIntegrationAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/MoleculeAction/VerletIntegrationAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * VerletIntegrationAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+class MoleculeListClass;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (std::string)
+#define paramtokens (MoleculeVerletIntegrationAction::NAME)
+#define paramreferences (forcesfile)
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Molecule
+#define ACTIONNAME VerletIntegration
+#define TOKEN "verlet-integrate"
+
Index: src/Actions/MoleculeAction/VerletIntegrationAction.hpp
===================================================================
--- src/Actions/MoleculeAction/VerletIntegrationAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/MoleculeAction/VerletIntegrationAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -10,31 +10,7 @@
 
 #include "Actions/Action.hpp"
-#include "Actions/Process.hpp"
 
-class MoleculeListClass;
-
-void MoleculeVerletIntegration(std::string &forcesfile);
-
-class MoleculeVerletIntegrationAction : public Action {
-  friend void MoleculeVerletIntegration(std::string &forcesfile);
-
-public:
-  MoleculeVerletIntegrationAction();
-  virtual ~MoleculeVerletIntegrationAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
-
+#include "VerletIntegrationAction.def"
+#include "Action_impl_header.hpp"
 
 #endif // VERLETINTEGRATIONACTION_HPP
Index: src/Actions/ParserAction/LoadXyzAction.cpp
===================================================================
--- src/Actions/ParserAction/LoadXyzAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/ParserAction/LoadXyzAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * LoadXyzAction.cpp
@@ -6,102 +13,38 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
+
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "Parser/XyzParser.hpp"
+
+#include <iostream>
 
 using namespace std;
 
 #include "Actions/ParserAction/LoadXyzAction.hpp"
-#include "Actions/ActionRegistry.hpp"
-#include "Parser/XyzParser.hpp"
-#include "atom.hpp"
-#include "log.hpp"
-#include "molecule.hpp"
-#include "verbose.hpp"
-#include "World.hpp"
 
-#include <iostream>
-#include <set>
-#include <string>
-#include <vector>
-
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
-
-/****** ParserLoadXyzAction *****/
-
-//// memento to remember the state when undoing
-//
-//class ParserLoadXyzState : public ActionState {
-//public:
-//  ParserLoadXyzState(molecule* _mol,std::string _lastName) :
-//    mol(_mol),
-//    lastName(_lastName)
-//  {}
-//  molecule* mol;
-//  std::string lastName;
-//};
-
-const char ParserLoadXyzAction::NAME[] = "parse-xyz";
-
-ParserLoadXyzAction::ParserLoadXyzAction() :
-  Action(NAME)
-{}
-
-ParserLoadXyzAction::~ParserLoadXyzAction()
-{}
-
-void ParserLoadXyz(std::string &filename) {
-  ValueStorage::getInstance().setCurrentValue(ParserLoadXyzAction::NAME, filename);
-  ActionRegistry::getInstance().getActionByName(ParserLoadXyzAction::NAME)->call(Action::NonInteractive);
-};
-
-Dialog* ParserLoadXyzAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryString(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
+// and construct the stuff
+#include "LoadXyzAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
 Action::state_ptr ParserLoadXyzAction::performCall() {
-  string filename;
-
-  ValueStorage::getInstance().queryCurrentValue(NAME, filename);
+  // obtain information
+  getParametersfromValueStorage();
 
   DoLog(1) && (Log() << Verbose(1) << "Parsing xyz file for new atoms." << endl);
   // parse xyz file
   ifstream input;
-  input.open(filename.c_str());
+  input.open(params.filename.c_str());
   if (!input.fail()) {
-    // TODO: Remove the insertion into molecule when saving does not depend on them anymore. Also, remove molecule.hpp include
-    set <atom*> UniqueList;
-    {
-      vector<atom *> ListBefore = World::getInstance().getAllAtoms();
-      for (vector<atom *>::iterator runner = ListBefore.begin();runner != ListBefore.end(); ++runner)
-        UniqueList.insert(*runner);
-    }
     XyzParser parser; // briefly instantiate a parser which is removed at end of focus
     parser.load(&input);
-    {
-      vector<atom *> ListAfter = World::getInstance().getAllAtoms();
-      pair< set<atom *>::iterator, bool > Inserter;
-      if (UniqueList.size() != ListAfter.size()) { // only create if new atoms have been parsed
-        MoleculeListClass *molecules = World::getInstance().getMolecules();
-        molecule *mol = World::getInstance().createMolecule();
-        molecules->insert(mol);
-        for (vector<atom *>::iterator runner = ListAfter.begin(); runner != ListAfter.end(); ++runner) {
-          Inserter = UniqueList.insert(*runner);
-          if (Inserter.second) { // if not present, then new (just parsed) atom, add ...
-            cout << "Adding new atom " << **runner << " to new mol." << endl;
-            mol->AddAtom(*runner);
-          }
-        }
-        mol->doCountAtoms();
-      } else {
-        cout << "No atoms parsed?" << endl;
-      }
-    }
   } else {
-    DoeLog(1) && (eLog() << Verbose(1) << "Could not open file " << filename << "." << endl);
+    DoeLog(1) && (eLog() << Verbose(1) << "Could not open file " << params.filename << "." << endl);
   }
   input.close();
@@ -134,2 +77,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/ParserAction/LoadXyzAction.def
===================================================================
--- src/Actions/ParserAction/LoadXyzAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/ParserAction/LoadXyzAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * LoadXyzAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (std::string)
+#define paramtokens (ParserLoadXyzAction::NAME)
+#define paramreferences (filename)
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Parser
+#define ACTIONNAME LoadXyz
+#define TOKEN "parse-xyz"
+
Index: src/Actions/ParserAction/LoadXyzAction.hpp
===================================================================
--- src/Actions/ParserAction/LoadXyzAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/ParserAction/LoadXyzAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -10,28 +10,7 @@
 
 #include "Actions/Action.hpp"
-#include "Actions/Process.hpp"
 
-void ParserLoadXyz(std::string &filename);
-
-class ParserLoadXyzAction : public Action {
-  friend void ParserLoadXyz(std::string &filename);
-
-public:
-  ParserLoadXyzAction();
-  virtual ~ParserLoadXyzAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "LoadXyzAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* LOADXYZACTION_HPP_ */
Index: src/Actions/ParserAction/SaveXyzAction.cpp
===================================================================
--- src/Actions/ParserAction/SaveXyzAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/ParserAction/SaveXyzAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * SaveXyzAction.cpp
@@ -6,8 +13,11 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/ParserAction/SaveXyzAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "Parser/XyzParser.hpp"
 #include "atom.hpp"
@@ -19,54 +29,19 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/ParserAction/SaveXyzAction.hpp"
 
-
-/****** ParserSaveXyzAction *****/
-
-//// memento to remember the state when undoing
-//
-//class ParserSaveXyzState : public ActionState {
-//public:
-//  ParserSaveXyzState(molecule* _mol,std::string _lastName) :
-//    mol(_mol),
-//    lastName(_lastName)
-//  {}
-//  molecule* mol;
-//  std::string lastName;
-//};
-
-const char ParserSaveXyzAction::NAME[] = "SaveXyz";
-
-ParserSaveXyzAction::ParserSaveXyzAction() :
-  Action(NAME)
-{}
-
-ParserSaveXyzAction::~ParserSaveXyzAction()
-{}
-
-void ParserSaveXyz(std::string &filename) {
-  ValueStorage::getInstance().setCurrentValue(ParserSaveXyzAction::NAME, filename);
-  ActionRegistry::getInstance().getActionByName(ParserSaveXyzAction::NAME)->call(Action::NonInteractive);
-};
-
-Dialog* ParserSaveXyzAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryString(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
+// and construct the stuff
+#include "SaveXyzAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
 Action::state_ptr ParserSaveXyzAction::performCall() {
-  string filename;
   XyzParser parser;
 
-  ValueStorage::getInstance().queryCurrentValue(NAME, filename);
+  // obtain information
+  getParametersfromValueStorage();
 
   // store xyz file
   ofstream output;
-  output.open(filename.c_str());
+  output.open(params.filename.c_str());
   if (!output.fail())
     parser.save(&output);
@@ -102,2 +77,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/ParserAction/SaveXyzAction.def
===================================================================
--- src/Actions/ParserAction/SaveXyzAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/ParserAction/SaveXyzAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * SaveXyzAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (std::string)
+#define paramtokens (ParserSaveXyzAction::NAME)
+#define paramreferences (filename)
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Parser
+#define ACTIONNAME SaveXyz
+#define TOKEN "SaveXyz"
+
Index: src/Actions/ParserAction/SaveXyzAction.hpp
===================================================================
--- src/Actions/ParserAction/SaveXyzAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/ParserAction/SaveXyzAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -10,28 +10,7 @@
 
 #include "Actions/Action.hpp"
-#include "Actions/Process.hpp"
 
-void ParserSaveXyz(std::string &filename);
-
-class ParserSaveXyzAction : public Action {
-  friend void ParserSaveXyz(std::string &filename);
-
-public:
-  ParserSaveXyzAction();
-  virtual ~ParserSaveXyzAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "SaveXyzAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* SAVEXYZACTION_HPP_ */
Index: src/Actions/Process.cpp
===================================================================
--- src/Actions/Process.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/Process.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * Process.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/Actions/SelectionAction/AllAtomsAction.cpp
===================================================================
--- src/Actions/SelectionAction/AllAtomsAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/SelectionAction/AllAtomsAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * AllAtomsAction.cpp
@@ -6,12 +13,15 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/SelectionAction/AllAtomsAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "Descriptors/AtomDescriptor.hpp"
 #include "atom.hpp"
-#include "log.hpp"
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
 
@@ -21,45 +31,18 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/SelectionAction/AllAtomsAction.hpp"
 
+// and construct the stuff
+#include "AllAtomsAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr SelectionAllAtomsAction::performCall() {
+  // obtain information
+  getParametersfromValueStorage();
 
-// memento to remember the state when undoing
-
-class SelectionAllAtomsState : public ActionState {
-public:
-  SelectionAllAtomsState(std::vector<atom*> _selectedAtoms) :
-    selectedAtoms(_selectedAtoms)
-  {}
-  std::vector<atom*> selectedAtoms;
-};
-
-const char SelectionAllAtomsAction::NAME[] = "select-all-atoms";
-
-SelectionAllAtomsAction::SelectionAllAtomsAction() :
-  Action(NAME)
-{}
-
-SelectionAllAtomsAction::~SelectionAllAtomsAction()
-{}
-
-void SelectionAllAtoms() {
-  ActionRegistry::getInstance().getActionByName(SelectionAllAtomsAction::NAME)->call(Action::NonInteractive);
-};
-
-Dialog* SelectionAllAtomsAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryEmpty(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
-Action::state_ptr SelectionAllAtomsAction::performCall() {
   std::vector<atom *> selectedAtoms = World::getInstance().getSelectedAtoms();
   DoLog(1) && (Log() << Verbose(1) << "Selecting all atoms." << endl);
   World::getInstance().selectAllAtoms(AllAtoms());
-  return Action::state_ptr(new SelectionAllAtomsState(selectedAtoms));
+  return Action::state_ptr(new SelectionAllAtomsState(selectedAtoms,params));
 }
 
@@ -71,13 +54,13 @@
     World::getInstance().selectAtom(*iter);
 
-  return Action::state_ptr(new SelectionAllAtomsState(state->selectedAtoms));
+  return Action::state_ptr(_state);
 }
 
 Action::state_ptr SelectionAllAtomsAction::performRedo(Action::state_ptr _state){
-  SelectionAllAtomsState *state = assert_cast<SelectionAllAtomsState*>(_state.get());
+  //SelectionAllAtomsState *state = assert_cast<SelectionAllAtomsState*>(_state.get());
 
   World::getInstance().selectAllAtoms(AllAtoms());
 
-  return Action::state_ptr(new SelectionAllAtomsState(state->selectedAtoms));
+  return Action::state_ptr(_state);
 }
 
@@ -93,2 +76,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/AllAtomsAction.def
===================================================================
--- src/Actions/SelectionAction/AllAtomsAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/SelectionAction/AllAtomsAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * AllAtomsAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#undef paramtypes
+#undef paramtokens
+#undef paramreferences
+
+#define statetypes (std::vector<atom*>)
+#define statereferences (selectedAtoms)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define ACTIONNAME AllAtoms
+#define TOKEN "select-all-atoms"
+
Index: src/Actions/SelectionAction/AllAtomsAction.hpp
===================================================================
--- src/Actions/SelectionAction/AllAtomsAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/SelectionAction/AllAtomsAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -11,26 +11,6 @@
 #include "Actions/Action.hpp"
 
-void SelectionAllAtoms();
-
-class SelectionAllAtomsAction : public Action {
-  friend void SelectionAllAtoms();
-
-public:
-  SelectionAllAtomsAction();
-  virtual ~SelectionAllAtomsAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "AllAtomsAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* ALLATOMSACTION_HPP_ */
